#!/bin/nawk -f 
# All Rights Reserved Copyright 2007 FUJITSU LIMITED
# *****************************************************************************
# * ǽ		եԤ碌ޥ
# * ¹Է		cvtlchkfile [-wait|-delete] [-var]
# * 				{ե̾|-file:ꥹȥե̾ [-AND|-OR]}
# * ѥ᥿	-wait	- եκԤ
# *			-delete - եκԤ
# *			-var - ѥե̾ꤹ˻
# *			ե̾ - оݥե̾
# *			-file:ꥹȥե̾ - оݥեե
# *			-AND|-OR - ꥹȥեΤ٤ƤΥեоݤ
# *				     Ȥ뤫ǤդΣեоݤȤ뤫
# *				     ꤹ
# *****************************************************************************
# * ǿ		
# *
# * 0001	2007/9/21	
# *****************************************************************************
BEGIN {
	# ռ
	"date +%Y%m%d" | getline today
	
	# Ķ
	"uname" | getline osname
	close("uname")
	# fuserޥ
	if (osname == "Linux") {
		# for Linux
		FUSERCMD = "/sbin/fuser"
	} else {
		FUSERCMD = "/usr/sbin/fuser"
	}

	# ե̾κĹ
	PATH_MAX=1024

	# Ԥ碌ǽեκ
	FILE_MAX=1000

	#**************************************************************************
	# Ѵ
	#**************************************************************************
	# 顼
	ERRMSG_FILEOPEN	= 1
	ERRMSG_DEFFILE 	= 2
	ERRMSG_BADFILE	= 3
	ERRMSG_DIRPATH	= 4
	ERRMSG_FILEOVER	= 5
	ERRMSG_FORMAT	= 6
	ERRMSG_USAGE	= 7

	# 顼åե
	errmsgfilename = "cvtlchkfile_errmsg"
	pwdir = "/var/opt/FJSVcvtl/command"
	errmsgpath = sprintf("%s/%s", pwdir, errmsgfilename)

	# iconvޥ
	ICONVCMD = "/usr/bin/iconv"

	# OMGRưĶѿ
	omgrenv = "BATCH"
	# OMGR LANGե
	langenvfilename="/opt/systemwalker/etc/systemwalker.reg"
	# LANGꥭ
	langkeyword="^Code="

	# OMGRưƤ뤫Υå
	isomgr = sprintf("%s", ENVIRON["JOBSCH_ENVIRONMENT"])
	if (isomgr == omgrenv) {
		# ե뤫LANG
		kwlinecmd = sprintf("/bin/grep \"%s\" %s", langkeyword, langenvfilename)
		kwlinecmd | getline kwline
		split(kwline,kw,"=")
		close(kwlinecmd)

		# iconvѴơ֥
		if (osname == "SunOS") {
			# Solarisξ
			iconveuc = "eucJP"
			if ( kw[2] == "SJIS" ) {
				# SJISξ
				toiconv = "PCK"
			} else {
				if ( kw[2] == "UTF-8" ) {
					# UTF8ξ
					toiconv = "UTF-8"
				}
			}
		} else {
			# Linuxξ
			iconveuc = "EUC-JP-MS"
			if ( kw[2] == "SJIS") {
				# SJISξ
				toiconv = "CP932"
			} else {
				if ( kw[2] == "UTF-8" ) {
					# UTF8ξ
					toiconv = "UTF-8"
				}
			}
		}
		# åΥѴ
		if (kw[2] == "SJIS" || kw[2] == "UTF-8") {
			errmsgcmd=sprintf("%s -f %s -t %s %s", ICONVCMD, iconveuc, toiconv, errmsgpath)
		} else {
			errmsgcmd = sprintf("cat %s", errmsgpath)
		}
	} else {
		# LANG
		mylang = sprintf("%s", ENVIRON["LANG"])

		# iconvѴơ֥
		if (osname == "SunOS") {
			# Solarisξ
			iconveuc = "eucJP"
			if (mylang == "ja_JP.PCK") {
				# SJISξ
				toiconv = "PCK"
			} else {
				if (mylang == "ja_JP.UTF-8") {
					# UTF-8ξ
					toiconv = "UTF-8"
				}
			}
		} else {
			# Linuxξ
			iconveuc = "EUC-JP-MS"
			if (mylang == "ja_JP.WINDOWS-31J") {
				# SJISξ
				toiconv = "CP932"
			} else {
				if ((mylang == "ja_JP.UTF-8") || (mylang == "ja_JP.utf8")) {
					# UTF-8ξ
					toiconv = "UTF-8"
				}
			}
		}

		# åΥѴʥ顼å
		if (mylang == "ja_JP.PCK" || mylang == "ja_JP.UTF-8" || mylang == "ja_JP.utf8" || mylang == "ja_JP.WINDOWS-31J") {
			errmsgcmd = sprintf("%s -f %s -t %s %s", ICONVCMD, iconveuc, toiconv, errmsgpath)
		} else {
			errmsgcmd = sprintf("cat %s", errmsgpath)
		}
	}
	while (errmsgcmd | getline > 0) {
		errmsgrl = $0

		# Ԥ⤷ϹƬ"#"ξɤФ
		if (errmsgrl == "" || errmsgrl ~ /^\#/) {
			continue
		}

		split(errmsgrl,edata,",")

		# ǡɤ߹
		errmsg[edata[1]] = edata[2]
	}
	close(errmsgcmd)

	#**************************************************************************
	# Υå
	#**************************************************************************
	# ץ󤬤ʤ
	if (ARGV[1] == "") {
		printf("%s\n", errmsg[ERRMSG_FORMAT])
		printf("%s\n", errmsg[ERRMSG_USAGE])
		exit (10)
	}

	for (i=1; i<ARGC; i++) {
		# Ԥξ
		if (ARGV[i] == "-wait") {
			if (wait_flag == 1 || delete_flag == 1) {
				printf("%s\n", errmsg[ERRMSG_FORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (10) 
			}
			wait_flag = 1
			continue
		# Ԥξ
		} else if (ARGV[i] == "-delete") {
			if (wait_flag == 1 || delete_flag == 1) {
				printf("%s\n", errmsg[ERRMSG_FORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (10)
			}
			delete_flag = 1
			continue
		# ѥե̾
		} else if (ARGV[i] == "-var") {
			if (var_flag == 1) {
				printf("%s\n", errmsg[ERRMSG_FORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (10)
			}
			var_flag = 1
			continue
		} else if (ARGV[i] == "-AND") {
			if (plural_flag == "") {
				# ʣեե饰AND
				plural_flag = "AND"
			} else {
				printf("%s\n", errmsg[ERRMSG_FORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (10)
			}
			continue
		} else if (ARGV[i] == "-OR") {
			if (plural_flag == "") {
				# ʣեե饰OR
				plural_flag = "OR"
			} else {
				printf("%s\n", errmsg[ERRMSG_FORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (10)
			}
			continue
		} else {
			# ʤ
			if (ARGV[i] == "") {
				break
			}
			# ˻ꤵƤ
			if (filename != "") {
				printf("%s\n", errmsg[ERRMSG_FORMAT])
				printf("%s\n", errmsg[ERRMSG_USAGE])
				exit (10)
			}
			# ʣեξ
			if (substr(ARGV[i],1,6) == "-file:") {
				# ե̾Ĺ0ʲޤ1024ʾ
                        	if (length(substr(ARGV[i],7)) == 0 || length(substr(ARGV[i],7)) > PATH_MAX) {
                                	printf("%s\n", errmsg[ERRMSG_FORMAT])
                                	printf("%s\n", errmsg[ERRMSG_USAGE])
                                	exit (10)
                        	}
					filename = substr(ARGV[i],7)
					# ʣե򼨤ե饰
					lst_flag = 1
					continue
			} else {
				# ե̾Ĺ0ʲޤ1024ʾ
                	        if (length(ARGV[i]) == 0 || length(ARGV[i]) > PATH_MAX) {
                        	        printf("%s\n", errmsg[ERRMSG_FORMAT])
                                	printf("%s\n", errmsg[ERRMSG_USAGE])
                                	exit (10)
                        	}
				# ե̾Ф
				filename = ARGV[i]
				continue
			}
		}
	}

	#**************************************************************************
	# ȹ礻å
	#**************************************************************************
	if (plural_flag == "") {
		# AND|ORʤξΥǥեȤAND
		plural_flag = "AND"
	}
	# ե̾ꤵƤʤ
	if (length(filename) == 0) {
		printf("%s\n", errmsg[ERRMSG_FORMAT])
		printf("%s\n", errmsg[ERRMSG_USAGE])
		exit (10)
	}

	#**************************************************************************
	# ʣեξ硢ꥹȥե뤫ꥹȤɤ߹
	#**************************************************************************
	# ꥹȥեɤ߹
	if (lst_flag == 1) {
		rc = chkfile_load_list(filename, lst_file)
		if (rc == 10) {
			# 顼ɤ߹߼
			exit (10)
		}
		if (rc == 1) {
			# ꥹȥեƤ
			exit (10)
 		}
	} else {
		# ñΥեξ
		lst_file[1] = filename	
	}
	#==========================================================================
	# ե̵ͭλ̵ͭΥåԤ
	#==========================================================================
	rc = chkfile_search(lst_file, lst_exist_flag, wait_flag, delete_flag, var_flag, plural_flag)

	exit (rc)
}


#******************************************************************************
# ʣեξ硢ե뤫ꥹȤɤ߹
#
#  
#           filenameԤ碌ꥹȥե̾
#         lst_fileեꥹ
#           ꥹɤ߹߷
#               0ｪλ
#               1եΥեޥåȤ
#               10顼
#****************************************************************************** 
function chkfile_load_list(filename, lst_file) {
	# եɤ߹ߤ˼Ԥ
	rc = system(sprintf("cat '%s' >/dev/null 2>&1", filename))
	if (rc != 0) {
		printf("%s %s\n", filename, errmsg[ERRMSG_FILEOPEN])
		return (10)
	}

	# եɤ߹
	i = 1
	cmd = sprintf("cat '%s'", filename)
	while (cmd | getline > 0) {
		rl = $0
		# Ԥξϥ롼Ƭ
		if (rl == "") {
			continue
		}

		# եѥå
		if (rl !~ /^\//) {
			printf("%s\n", errmsg[ERRMSG_DEFFILE])
			return(1)
		}
		# ʣեå
		lchk = 0
		if (i > 1) {
			for (j=1; j<i; j++) {
				if (rl == lst_file[j]) {
					lchk = 1
					break
				}
			}
			# ʣեϥꥹȤʤ
			if (lchk == 1) {
				continue
			}
		}
		# ե1000Ĥޤ
		if (i > FILE_MAX) {
			printf("%s\n", errmsg[ERRMSG_FILEOVER])
			return (1)
		# եǼ
		} else {
			lst_file[i] = rl
			i = i + 1
		}
	}
	close(cmd)

	# եꥹȤå
	if (i == 1) {
		printf("%s\n", errmsg[ERRMSG_DEFFILE])
		return (1)
	} else {	
		# Ǥʤ
		return (0)
	}
}


#==============================================================================
# ե̵ͭλΥåԤ
#
#  
#           lst_file	:Ԥ碌եꥹ
#               wait_flag	:ԤȽե饰
#               delete_flag	:ԤȽե饰
#               var_flag	:ѥե̾ե饰
#               plural_flag	:AND|ORե饰
#           åԤä
#               0	:ե뤬줿
#               1	:ե뤬¸ߤʤ
#               10	:顼
#==============================================================================
function chkfile_search(lst_file, lst_exist_flag, wait_flag, delete_flag, 
			var_flag, plural_flag) {

	# Ʊʣ¹ԤΤɤᡢ1Ԥ
	system(sprintf("/bin/sleep 1"))
	# ٤ƤΥեå
	for (i=1; lst_file[i] != ""; i++) {
		# եѥå
		if (lst_file[i] !~ /^\//) {
			printf("%s %s\n", lst_file[i], errmsg[ERRMSG_BADFILE])
			return (10)
		}
	}

	# Ѵ
	if (var_flag == 1) {
		for (i=1; lst_file[i] != ""; i++) {
			lst_file[i] = conv_filename(lst_file[i])
		}
	}

	# åե
	file_cnt = i - 1

	#==========================================================================
	# ¸ߥե饰ꤹ
	#==========================================================================
	# ե¸ߤĴ٤
	exist_cnt = chkfile_compare(lst_file, lst_exist_flag, lst_exist_num, var_flag)
	if (exist_cnt == -10) {
		# 顼
		return (10)
	}
	# ֤ˤ¸ߤե¸
	for (i=1; lst_exist_num[i] != ""; i++) {
		exist_num[i] = lst_exist_num[i]
	}
	#==========================================================================
	# -deleteξ
	#  ǽ餫ƤΥե뤬¸ߤʤANDꡧ۾ｪλ
	#  OR ｪλ
	#  ORξϺǽ餫Ǥ⡢¸ߤʤե뤬1ĤǤ⤢ｪλ
	#==========================================================================
	# Ԥξ
	if (delete_flag == 1) {
		if (plural_flag == "OR") {
			# ե뤬ĤǤʤ
			if (exist_cnt != file_cnt) {
				return (0)
			}
		# AND
		} else {
			# ե뤬Ĥ¸ߤʤ
			if (exist_cnt == 0) {
				return (1)
			}
		}
	}

	#==========================================================================
	# ʤե¸ߥå
	#  And
	#      ե뤬¸               ͣǽλ
	#      ե뤬ĤǤʤ          	ͣǽλ
	#  OR
	#      ե뤬ĤǤ¸           ͣǽλ
	#      ե뤬Ĥʤ             ͣǽλ
	#==========================================================================
	if ((wait_flag == 0) && (delete_flag == 0)) {
		# AND
		if (plural_flag == "AND") {
			# ٤ƤΥե뤬¸ߤ
			if (exist_cnt == file_cnt) {
				return (0)
			# ե뤬ĤǤʤ
			} else {
				return (1)
			}
		# OR
		} else {
			# ե뤬Ĥʤ
			if (exist_cnt == 0) {
				return (1)
			# ե뤬ĤǤ¸ߤ
			} else {
 				return (0)
			}
		}
	}

	#==========================================================================
	# Ԥ碌֤ˤʤޤǥեξ֤򷫤֤å
	#==========================================================================
	proc_flag = 0
	while (1) {

		# ե¸ߤĴ٤
		exist_cnt = chkfile_compare(lst_file, lst_exist_flag, lst_exist_num, var_flag)
		if (exist_cnt == -10) {
			# 顼
			return (10)
		}

		#**************************************************************
		# -waitξ
		#**************************************************************
		if (wait_flag) {
			rc = wait_proc(plural_flag, exist_cnt, file_cnt)
			if (rc == 0) {
				# 줿
				return (0)
			}
		}

		#**************************************************************
		# -deleteξ
		#**************************************************************
		if (delete_flag) {
			rc = delete_proc(exist_num, lst_exist_num, plural_flag, exist_cnt, file_cnt)
			if (rc == 0) {
				# 줿
				return (0)
			}
		}

		# 1äȤ˥եå
		system(sprintf("/bin/sleep 1 >/dev/null 2>&1"))
	}
} 



#==============================================================================
# ꤷե¸ߥå
#
#  
#           lst_file      Ԥ碌եꥹ
#               lst_exist_flagե̵ͭ
#		lst_exist_num ¸ߤե
#               var_flag      ѥե̾ե饰
#           å
#               -10     顼
#               嵭ʳ¸ߤեο
#==============================================================================
function chkfile_compare(lst_file, lst_exist_flag, lst_exist_num, var_flag) {

	# exist_cntν
	exist_cnt = 0
	for (i=1; lst_file[i] != ""; i++) { 
		# ¸ߤե
		lst_exist_num[i] = 0
		# 磻ɥɻꤵƤ뤫åʥե饰򤿤Ƥ
		wild_flag = 0
		if ((index(lst_file[i],"*") != 0) || (index(lst_file[i],"?") != 0)) {
			wild_flag = 1
		}
		# -varꤢ磻ɥɻꤢ
		if ((var_flag == 1) && (wild_flag == 1)) {
			esc_file = escape_meta(lst_file[i])
			# ե¸ߥե饰
			cmp_file_flag = 0
			cmpcmd = sprintf("ls -1 %s 2>/dev/null", esc_file)
			while (cmpcmd | getline > 0) {
				# ɤ߹
				rl = $0
				# 磻ɥɤǥǥ쥯ȥ꤬ꤵƤ
				# ɤФ
				if (index(rl, "/") == 0) {
					continue
				} 
				# ե뤬¸ߤfile_flag1
				cmp_file_flag = 1
				# ¸ߤե򹹿
				lst_exist_num[i] = lst_exist_num[i] + 1
			}
			close(cmpcmd)
			# ե뤬ĤǤ⤢
			if (cmp_file_flag == 1) {
				lst_exist_flag[i] = 1
				exist_cnt = exist_cnt + 1
			# ե뤬ʤ
			} else {
				lst_exist_flag[i] = 0
			}

		# -varʤ
		} else {
			# ե뤫ǥ쥯ȥ꤫Ĵ٤
 			cmp_rc_test = system(sprintf("/usr/bin/test -d '%s' >/dev/null 2>&1", lst_file[i]))
			# ǥ쥯ȥξ
			if (cmp_rc_test == 0) {
				printf("%s %s\n", lst_file[i], errmsg[ERRMSG_BADFILE])
				return (-10)
			} else {
				# ե̵ͭ򸡺
				cmp_rc = system(sprintf("ls '%s' >/dev/null 2>&1", lst_file[i]))
				# ե뤬ʤ
				if (cmp_rc != 0) {
					lst_exist_flag[i] = 0
				# ե뤬
				} else {
					lst_exist_flag[i] = 1
					exist_cnt = exist_cnt + 1
					# ¸ߤե򹹿
					lst_exist_num[i] = lst_exist_num[i] + 1
				}
			}
		}
	}
	return (exist_cnt)
}


#==============================================================================
# ե̾ѿդѴ
#
#  
#   ϡ      filenameե̾
#   ϡ      filenameե̾Ѵ
#==============================================================================
function conv_filename(filename) {
	convname = filename

	# ѿβʬ֤
	while (match(convname, /\#\{[^#}]*\}/) != 0) {
		# #{date}̵ͭå
		idx = match(convname, /\#\{[^#}]*\}/)
		m = substr(convname,idx+2,RLENGTH-3)

		# ǯʣ
		gsub(/yyyy/, substr(today,1,4), m)
		# ǯʣ
		gsub(/yy/, substr(today,3,2),m)
		# 
		gsub(/mm/, substr(today,5,2),m)
		# 
		gsub(/dd/, substr(today,7,2),m)

		# Ѵ¹
		sub(/\#\{[^#}]*\}/, m, convname)
	}
	return (convname)
}



#==============================================================================
# եκԤ
#  ANDꡧ٤ƤΥե뤬¸ߤ
#  OR ĤǤե뤬¸ߤ
#
#  
#           plural_flag"-AND","-OR"ե饰
#               exist_cnt  ¸ߤե
#               file_cnt   åե
#           եԤη
#               0줿
#               1Ƥʤ
#==============================================================================
function wait_proc(plural_flag, exist_cnt, file_cnt) {
	# OR
	if (plural_flag == "OR") {
		# ĤǤե뤬¸ߤ
		if (exist_cnt != 0) {
			# ͣ
			rc_wp = 0
		} else {
			# ͣ
			rc_wp = 1
		}
	# AND
	} else {
		# ٤ƤΥե뤬¸ߤ
		if (exist_cnt == file_cnt) {
			# ͣ
			rc_wp = 0
		} else {
			# ͣ
			rc_wp = 1
		}
	}

	# 
	return (rc_wp)
}


#==============================================================================
# եκԤ
#  ANDꡧ٤ƤΥե뤬뢪ǽλ
#  OR ĤǤե뤬뢪ǽλ
#
#  
#           plural_flag"-AND","-OR"ե饰
#               exist_cnt  ¸ߤե
#               file_cnt   åե
#		exist_num  ֤ˤ¸ߤե
#		lst_exist_num¸ߤե
#           եκԤη
#               0줿
#               1Ƥʤ
#==============================================================================
function delete_proc(exist_num, lst_exist_num, plural_flag, exist_cnt, file_cnt) {
	# OR
	if (plural_flag == "OR") {
		# ĤǤե뤬¸ߤʤ
		if (exist_cnt != file_cnt) {
			# ͣ
			rc_dp = 0
		} else {
			# ͣ
			rc_dp = 1
			# 磻ɥɻꤵ줿ϡ¸ߤե
			# ֤飱ĤǤ⸺äƤ1
			for (i=1; lst_exist_num[i] != ""; i++) {
				if (exist_num[i] > lst_exist_num[i]) {
					rc_dp = 0
				}
			}
		}
	# AND
	} else {
		# ٤ƤΥե뤬¸ߤʤ
		if (exist_cnt == 0) {
			# ͣ
			rc_dp = 0
		} else {
			# ͣ
			rc_dp = 1
		}
	}

	# 
	return (rc_dp)
}


#==============================================================================
# ᥿ʸ򥨥סʥ磻ɥʸʳ
#
#  
#   	filenameե̾
#   	filenameե̾Ѵ
#==============================================================================
function escape_meta(filename) {
	convname = filename

	# \ 򥨥
	gsub(/\\/, "\\\\", convname)
	# " 򥨥
        gsub(/"/, "\\\"", convname)
	# ` 򥨥
        gsub(/`/, "\\`", convname)
	# | 򥨥
        gsub(/\|/, "\\|", convname)
	# | 򥨥
        gsub(/!/, "\\!", convname)
	# ~ 򥨥
        gsub(/~/, "\\~", convname)
	# $ 򥨥
        gsub(/\$/, "\\$", convname)
	# < 򥨥
        gsub(/</, "\\<", convname)
	# > 򥨥
        gsub(/>/, "\\>", convname)
	# & 򥨥
        gsub(/\&/, "\\\\&", convname)
	# [ 򥨥
        gsub(/\[/, "\\[", convname)
	# ] 򥨥
        gsub(/\]/, "\\]", convname)
	# # 򥨥
        gsub(/#/, "\\#", convname)
	# ( 򥨥
        gsub(/\(/, "\\(", convname)
	# ) 򥨥
        gsub(/\)/, "\\)", convname)
	# { 򥨥
        gsub(/{/, "\\{", convname)
	# } 򥨥
        gsub(/}/, "\\}", convname)
	# ; 򥨥
        gsub(/;/, "\\;", convname)
	# ^ 򥨥
        gsub(/\^/, "\\^", convname)
	# ' 򥨥
        gsub(/'/, "\\'", convname)
	# 򥨥
	gsub(/\ /, "\\ ", convname)

	# 
	return (convname)
}
